# vim: set fileencoding=ascii ts=4 sw=4 sts=0 :
# Copyright (C) 2004, Shu KONNO <owa@bg.wakwak.com> All Rights Reserved.
from CSpace import CSpace
import string

class CScript(CSpace):
	def __init__(self):
		self.newpos = None
		self.prepos = None
		self.outpos = None

	def get(self):
		return self.newpos, self.prepos, self.outpos

	def set(self, dst, src, cap=None):
		self.newpos = dst
		self.prepos = src
		self.outpos = cap

	def _flip(self, s):
		if s and s[2:]:
			p = s[2]
			if p == '+':
				return s[:2] + '-'
			if p == '-':
				return s[:2] + '+'
		return s

	def plus(self):
		s = self.prepos
		if s:
			if s[2:]:
				self.prepos = s[:2]
			else:
				self.prepos = s[:2] + '+'

	def gets(self):
		s = self.newpos
		if self.prepos:
			s += self.prepos
		if self.outpos:
			s += '(' + self.outpos
		return s

	def sets(self, s):
		self.outpos = None
		c = string.split(s, '(')
		if len(c) >= 2:
			self.outpos = c[1]
			s = c[0]
		self.newpos = s[:2]
		self.prepos = s[2:]

	def setp(self, dst, pick):
		self.newpos = dst
		self.outpos = None
		if not pick[2]: # dropon
			self.prepos = pick[0] + pick[1]
		else:			# moveto
			self.prepos = pick[2]
			piece = self.what(dst)
			if piece:	# capture
				self.outpos = piece[1:]

