# vim: set fileencoding=ascii ts=4 sw=4 sts=0 :
# Copyright (C) 2004, Shu KONNO <owa@bg.wakwak.com> All Rights Reserved.
from __init__ import opening_stage_figure
from CSpace import CSpace
#import C14gBoard, C31cBoard
import C14gBoard
import PIL.Image, string

#space_board = {0:C14gBoard.CxBoard, 1:C31cBoard.CxBoard}
space_board = {0:C14gBoard.CxBoard}

class ViewSpace(CSpace):
	def __init__(self, diagram=None, size=0):
		CSpace.__init__(self)
		self.ban = space_board.get(int(size), C14gBoard.CxBoard)()
		if diagram:
			diagram = opening_stage_figure.get(diagram, diagram)
			CSpace.putDiagram(self, diagram)

	def pickupTarget(self, pos, id=0):
		return self.ban.pickupTarget(self, pos, id)

	def getposFromCoord(self, pos):
		return self.ban.getColRow(pos)

	def getPuzzleImage(self, pick=None):
		b = self.ban.getBoardImage(self, pick)
		c = self.ban.getBlacketImg(self, 1)
		x = b.size[0] + c.size[0]
		y = b.size[1]
		img = PIL.Image.new('RGB',(x, y),(255,255,255))
		img.paste(b, (0, 0))
		img.paste(c, (b.size[0], b.size[1] - c.size[1]))
		return self._img2file(img, 'png')

	def getWholeImage(self, pick=None):
		a = self.ban.getBlacketImg(self, 2)
		b = self.ban.getBoardImage(self, pick)
		c = self.ban.getBlacketImg(self, 1)
		x = a.size[0] + b.size[0] + c.size[0]
		y = b.size[1]
		img = PIL.Image.new('RGB',(x, y),(255,255,255))
		img.paste(a, (0, 0))
		img.paste(b, (a.size[0], 0))
		img.paste(c, (a.size[0] + b.size[0], b.size[1] - c.size[1]))
		return self._img2file(img, 'png')

	def getBoardImage(self, pick=None):
		img = self.ban.getBoardImage(self, pick)
		return self._img2file(img, img.format)

	def getBlackBlacket(self, pick=None, size=0):
		img = self.ban.getBlacketImg(self, 1, pick)
		return self._img2file(img, 'PNG')

	def getWhiteBlacket(self, pick=None, size=0):
		img = self.ban.getBlacketImg(self, 2, pick)
		return self._img2file(img, 'PNG')

	def _img2file(self, img, fmt):
		import cStringIO
		ram = cStringIO.StringIO()
		img.save(ram, fmt)
		ram.seek(0)
		return ram.getvalue()

