# vim: set fileencoding=ascii ts=4 sw=4 sts=0 :
# Copyright (C) 2004, Shu KONNO <owa@bg.wakwak.com> All Rights Reserved.
from CSpace import CSpace

__stage_list = (
	('S0', 'single', '2K55,R*2,B*2,G*4,S*4,N*4,L*4,P*18'),
	('D0', 'double', '2K51,R,B,G*2,S*2,N*2,L*2,P*9,1K59,R,B,G*2,S*2,N*2,L*2,P*9'),
	('H0', 'even game ', 'K51,G61,G41,S71,S31,N81,N21,L91,L11,R82,B22'),
	('H1', '1-handicap', 'K51,G61,G41,S71,S31,N81,N21,L91,R82,B22'),
	('H2', '2-handicap', 'K51,G61,G41,S71,S31,N81,N21,L91,L11,R82'),
	('H3', '3-handicap', 'K51,G61,G41,S71,S31,N81,N21,L91,L11,B22'),
	('H4', '4-handicap', 'K51,G61,G41,S71,S31,N81,N21,L91,B22'),
	('H5', '5-handicap', 'K51,G61,G41,S71,S31,N81,N21,L91,L11'),
	('H6', '6-handicap', 'K51,G61,G41,S71,S31,N81,N21'),
	('H7', '7-handicap', 'K51,G61,G41,S71,S31'),
	('H8', '8-handicap', 'K51,G61,G41'),
)
__even = """
1P97,P87,P77,P67,P57,P47,P37,P27,P17,
K59,G69,G49,S79,S39,N89,N29,L99,L19,B88,R28,
2P93,P83,P73,P63,P53,P43,P33,P23,P13,
"""
def getLabels():
	""" method to get labels of the opening types """
	labels = []
	for type in __stage_list:
		labels.append(type[:2])
	return labels

def getFigure():
	""" method to get the diagrams by the opening type """
	scripts = {}
	for type in __stage_list:
		k = type[0]
		s = type[2]
		if k[0] == 'H':
			s = __even + s
		scripts[k] = s
	return scripts

