# vim: set fileencoding=euc-jp ts=4 sw=4 sts=0 formatoptions= :
# Copyright (C) 2004, Shu KONNO <owa@bg.wakwak.com> All Rights Reserved.
from Tkinter import *
from ZFrame import ZFrame
from board9.CntlSpace import COpenSpace, VCOpenSpace
from board9 import opening_stage_labels

class ZShogiOpen(ZFrame):
	def __init__(self, master, diag='', size=0):
		self.diag = diag
		ZFrame.__init__(self, master, diag, size)
		self.diagPanel.set(self.diag)

	def selected(self, id=0):
		self.diag = opening_stage_labels[id][0]
		self.pick = ''
		self.showImage()
		self.diagPanel.set(self.diag)

	def getListBox(self, frame):
		panel = Frame(frame, bd=1)
		self.listbox = Listbox(panel, bd=1, width=10, height=11)
		self.listbox.pack(side=LEFT, fill=BOTH, expand=1)
		for s in opening_stage_labels:
			self.listbox.insert(END, s[1])
		return panel

	def controlBox(self, frame):
		bt = Button(frame, text=u'quit', bd=1, command=self.quit)
		bt.pack(side=LEFT)
		bt = Button(frame, text=u'promote', bd=1, command=self.promote)
		bt.pack(side=LEFT)
		bt = Button(frame, text=u'roll', bd=1, command=self.roll)
		bt.pack(side=LEFT)

	def promote(self):
		if self.pick[2]:
			space = COpenSpace(self.diag)
			space.plus(self.pick)
			self.diag = space.getDiagram()
			self.pick = None
			self.showImage()

	def roll(self):
		if self.pick:
			space = COpenSpace(self.diag)
			space.roll(self.pick)
			self.diag = space.getDiagram()
			self.pick = None
			self.showImage()

	def proc(self, pos, id):
		""" method to layout pieces positioning """
		if self.pick:
			space = VCOpenSpace(self.diag, self.size)
			dst = space.getposFromCoord(pos)
			space.move(dst, self.pick, id)
			self.diag = space.getDiagram()
			self.pick = None
		else:
			space = VCOpenSpace(self.diag, self.size)
			self.pick = space.pickupTarget(pos, id)
		self.showImage()

	def showImage(self):
		ZFrame.showImage(self)
		if self.pick:
			self.message.set(self.pick)
		self.diagPanel.set(self.diag)

