# vim: set fileencoding=euc-jp ts=4 sw=4 sts=0 formatoptions= :
# Copyright (C) 2004, Shu KONNO <owa@bg.wakwak.com> All Rights Reserved.
from Tkinter import *
from ZFrame import ZFrame
from board9.CntlSpace import CPlaySpace

class ZShogiPlay(ZFrame):
	def __init__(self, master, diag='', hist='', numb=0, side='1', size=0):
		self.diag = diag
		self.hist = hist
		self.side = side
		self.numb = numb
		self.nmax = len(hist.split(','))
		ZFrame.__init__(self, master, diag, size)
		w0 = self.canvBoard['width']
		w1 = self.canvBlacket1['width']
		w2 = self.canvBlacket2['width']
		self.canvBoard['width'] = str(int(w0) + int(w1) + int(w2))
		self.canvBlacket1['width'] = '1'
		self.canvBlacket2['width'] = '1'
		self.diagPanel.set(self.diag)

	def getListBox(self, frame):
		panel = Frame(frame, bd=1)
		scrollbar = Scrollbar(panel, orient=VERTICAL)
		self.listbox = Listbox(panel, bd=1, width=10, height=11,
			yscrollcommand=scrollbar.set)
		scrollbar.config(command=self.listbox.yview)
		self.listbox.pack(side=LEFT, fill=BOTH, expand=1)
		scrollbar.pack(side=LEFT, fill=Y)
		self.listbox.insert(END, self.hist.split(','))
		return panel

	def selected(self, id=0):
		pass

	def controlBox(self, frame):
		bt = Button(frame, text=u'Quit', bd=1, command=self.quit)
		bt.pack(side=LEFT)
		bt = Button(frame, text=u'|<', bd=1, command=self.__head)
		bt.pack(side=LEFT)
		self.bt_head = bt
		bt = Button(frame, text=u'<<', bd=1, command=self.__prev)
		bt.pack(side=LEFT)
		self.bt_prev = bt
		bt = Button(frame, text=u'>>', bd=1, command=self.__next)
		bt.pack(side=LEFT)
		self.bt_next = bt
		bt = Button(frame, text=u'>|', bd=1, command=self.to_tail)
		bt.pack(side=LEFT)
		self.bt_tail = bt

	def __next(self):
		space = CPlaySpace(self.diag, self.hist, self.numb)
		s = space.next(1)
		self.diag = space.getDiagram()
		self.numb = space.getSequence()
		self.message.set('%d:%s' % (self.numb, s))
		self.showImage()

	def __prev(self):
		space = CPlaySpace(self.diag, self.hist, self.numb)
		s = space.prev(1)
		self.diag = space.getDiagram()
		self.numb = space.getSequence()
		self.message.set('%d:%s' % (self.numb, s))
		self.showImage()

	def __head(self):
		space = CPlaySpace(self.diag, self.hist, self.numb)
		s = space.prev()
		self.diag = space.getDiagram()
		self.numb = space.getSequence()
		self.message.set('%d:%s' % (self.numb, s))
		self.showImage()

	def to_tail(self):
		space = CPlaySpace(self.diag, self.hist, self.numb)
		s = space.next()
		self.diag = space.getDiagram()
		self.numb = space.getSequence()
		self.message.set('%d:%s' % (self.numb, s))
		self.showImage()

	def showImage(self):
		if self.hist and self.numb > 0:
			self.bt_head['state'] = 'active'
			self.bt_prev['state'] = 'active'
		else:
			self.bt_head['state'] = 'disabled'
			self.bt_prev['state'] = 'disabled'

		if self.numb < self.nmax:
			self.bt_next['state'] = 'active'
			self.bt_tail['state'] = 'active'
		else:
			self.bt_next['state'] = 'disabled'
			self.bt_tail['state'] = 'disabled'

		ZFrame.showImageAll(self)
		self.diagPanel.set(self.diag)
		self.__showHistory()

	def __showHistory(self):
		self.listbox.delete(0, END)
		if self.hist:
			hist = self.hist.split(',')
			bw = self.side;
			for s in hist:
				self.listbox.insert(END, bw + ':' + s)
				if bw == '1':
					bw = '2' 
				else:
					bw = '1' 
			self.listbox.insert(END, bw + ':')
			self.listbox.select_set(self.numb)

